import { ResourceDefinition } from './resource-definition';
export interface UnthinkViewRenderer {
    (template: string, value?: unknown): string;
}
export interface UnthinkGeneratorBackend<ResourceMiddleware> {
    generate(resourceDefinitions: ResourceDefinition<ResourceMiddleware>[]): void;
}
export declare class UnthinkGenerator<ResourceMiddleware> {
    private resourceDefinitions;
    private generatorBackend;
    constructor(generatorBackend: UnthinkGeneratorBackend<ResourceMiddleware>);
    add(resourceDefinition: ResourceDefinition<ResourceMiddleware>): UnthinkGenerator<ResourceMiddleware>;
    generate(): void;
}
