import { DataResult, ViewResult } from './result';
import { ResourceConfig, ResourceMethodMap, ResourceRouteDefinition, ResourceRouteHandler, ResourceViewRouteDefinition } from './resource-definition';
export declare function data<ResourceMiddleware>(path: string, methods: ResourceMethodMap<DataResult, ResourceMiddleware>, config?: ResourceConfig<ResourceMiddleware>): ResourceRouteDefinition<ResourceMiddleware>;
export declare function view<ResourceMiddleware>(path: string, handler: string | ResourceRouteHandler<ViewResult, ResourceMiddleware>, config?: ResourceConfig<ResourceMiddleware>): ResourceViewRouteDefinition<ResourceMiddleware>;
